/*
 * mxheader.c -- return first header from a mail message
 */

#include <unistd.h>

const int bs = 1<<10;

#define NEXT_CHAR offset++; more--; if(more <= 0) {more = read(0, buf, bs); if(more <= 0) return 1; offset = 0;}

int
main(int argc, char **argv) {
  char buf[bs];
  char *arg;
  int offset=0, more=0, alphanum=0;

  if(argc < 2) { return 100; }
  for(arg = argv[1]; *arg != '\0'; arg++) {
    *arg |= 0x20; /* lower case */
  }
  arg = argv[1];

  more = read(0, buf, bs); offset = 0;
  while(1) { /* for each header */
    alphanum = 0;
    if(buf[offset] == '\n' || buf[offset] == '\r') return 1; /* end of headers */
    while((buf[offset] | 0x20) == arg[alphanum]) {
      alphanum++; NEXT_CHAR;
    }
    if(arg[alphanum] == '\0' && buf[offset] == ':') {
      NEXT_CHAR;
      break;
    } else {
      do { /* for each line of header */
	do { NEXT_CHAR } while(buf[offset] != '\n');
	NEXT_CHAR;
      } while(buf[offset] == ' ' || buf[offset] == '	');
    }
  }

  /* skip whitespace between colon and contents */
  while(buf[offset] == ' ' || buf[offset] == '	') { NEXT_CHAR };
  if(buf[offset] != '\n' && buf[offset] != '\r')
  do { /* for each line of header */
    if(buf[offset] == ' ' || buf[offset] == '	') { NEXT_CHAR };
    alphanum = offset;
    do { 
      offset++; more--;
      if(more <= 0) {
	write(1, buf+alphanum, offset - alphanum);
	more = read(0,buf,bs);
	alphanum = offset = 0;
      }
    } while(buf[offset] != '\n' && buf[offset] != '\r');
    write(1, buf+alphanum, offset - alphanum);
    if(buf[offset] == '\r') { NEXT_CHAR; }
    if(buf[offset] == '\n') { NEXT_CHAR; }
  } while(buf[offset] == ' ' || buf[offset] == '	');
  write(1,"\n",1);

  return 0;
}

